// =============================================================== //
//                                                                 //
//   File      : AP_TreeSet.cxx                                    //
//   Purpose   : function for sets of tree nodes                   //
//                                                                 //
//   Coded by Ralf Westram (coder@reallysoft.de) in January 2017   //
//   http://www.arb-home.de/                                       //
//                                                                 //
// =============================================================== //

#include "AP_TreeSet.hxx"

using namespace std;

void collect_enclosing_groups(AP_tree *node, AP_tree_set& groups) {
    node = node->get_father();
    while (node) {
        if (node->is_named_group()) {
            groups.insert(node);
        }
        node = node->get_father();
    }
}

void collect_contained_groups(AP_tree *node, AP_tree_set& groups) {
    if (!node->is_leaf) {
        if (node->is_named_group()) groups.insert(node);
        collect_contained_groups(node->get_leftson(), groups);
        collect_contained_groups(node->get_rightson(), groups);
    }
}
